#pragma once
#include "DS_cube.h"
#include "PoroMediaDialogShare.h"
#include <iostream>

unsigned char median(unsigned char input [], unsigned char l);
unsigned char median_w_averaging(unsigned char input [], unsigned char l, unsigned char n_med);

void ds_median_first_slice(DS_cube* ds_input, DS_slice* buffer_slice);
void ds_median_mid_slice(DS_cube* ds_input, DS_slice* buffer_slice, register unsigned short int k);
void ds_median_last_slice(DS_cube* ds_input, DS_slice* buffer_slice);

void ds_median_w_averaging_first_slice(DS_cube* ds_input, DS_slice* buffer_slice);
void ds_median_w_averaging_mid_slice(DS_cube* ds_input, DS_slice* buffer_slice, register unsigned short int k);
void ds_median_w_averaging_last_slice(DS_cube* ds_input, DS_slice* buffer_slice);


void ds_median_first_slice_cube(DS_cube* ds_input, DS_cube* ds_output);
void ds_median_mid_slice_cube(DS_cube* ds_input, DS_cube* ds_output, register unsigned short int depth_output, register unsigned short int k);
void ds_median_last_slice_cube(DS_cube* ds_input, DS_cube* ds_output, register unsigned short int depth_output);


bool ds_median_w_center(DS_cube* ds_input, void* dlg_share);
bool ds_median_w_averaging_w_center(DS_cube* ds_input, void* dlg_share);